###########################################################################
#
#   Copyright (c) 2000 Morten W. Petersen <morten@esol.no>
#	Copyright (c) 2000 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Author: morten $
# $Revision: 1.5 $


__doc__ = 'Documentation string.'
__version__ = '0.1.0'

from Globals import HTMLFile
from Globals import Persistent
from Globals import default__class_init__
import Acquisition
import AccessControl.Role
import Products
from Products.BTreeFolder.BTreeFolder import BTreeFolder
#import OFS.Folder
import base_item


news_group_storage_add_redirect = HTMLFile('news_group_storage_add_redirect', globals())
manage_add_news_group_storage_form = HTMLFile('news_group_storage_add', globals())


def manage_add_news_group_storage(self, id, title,
								  REQUEST=None, RESPONSE=None):
    "Add an instance of the NewsGroupStorage class"

    self._setObject(id, news_group_storage(id, title))

    if REQUEST is not None and RESPONSE is not None:

		RESPONSE.redirect(self.absolute_url())


class news_group_storage(
	Products.ZCatalog.CatalogAwareness.CatalogAware,
	BTreeFolder,
	#OFS.Folder.Folder,
	Persistent,
	Acquisition.Implicit,
	AccessControl.Role.RoleManager,
	base_item.base_item
	):
	"Documentation string"

	meta_type = 'NewsGroupStorage'
	icon = 'misc_/Transform/Folder_icon.gif'

	_properties = (
		{'id':'title', 'type':'string'},
		)

	#meta_types = (
	#	{'name':'NewsGroupStorage', 'action':'manage_add_news_group_storage_form'},
	#	)

	#manage_add_news_group_storage_form = news_group_folder.manage_add_news_group_folder_form
	#manage_add_news_group_folder = news_group_folder.manage_add_news_group_folder
	#news_group_folder_add_redirect = news_group_folder.news_group_folder_add_redirect

	__ac_permissions__ = (
		('View management screens',
		 ('manage_tabs', 'manage_main')),
		('Change Permissions',
		 ('manage_access',)),
		#('Add NewsGroupFolder',
		# ('manage_add_news_group_folder', 'manage_add_news_group_folder_form')),
		('View NewsGroupStorages',
		 ('',)),
		)

	index_html = HTMLFile('news_group_storage_index', globals())


	def get_all_message_headers(self):
		"""Returns all message headers."""

		return map(lambda x: x.headers, self.objectValues('RFC822Message'))


	def get_message_headers(self, message_id):
		"""Returns the message headers of given message (id)."""

		return self[message_id].headers


	def get_multiple_message_headers(self, message_ids=[]):
		"""Returns multiple sets of message headers."""

		message_headers = []

		for message_id in message_ids:

			message_headers.append(self.get_message_headers(message_id))

			# FIXME
			# This is a bad hack, so we know where to point to
			# when a user wants to read the actual message..

			message_headers[-1]['x_newshost_message_id'] = message_id

		return message_headers


	def number_of_articles(self):
		"""Returns the number of articles contained."""

		return len(self.objectIds())


	def __init__(self, id, title=''):
		"Initialize the class instance"

		self.id = id
		self.title = title

		self.last_retrieved_message = 0


	def get_messages(self):
		"""Returns a list of the messages contained."""

		return self.objectValues('RFC822Message')


default__class_init__(news_group_storage)

